<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCANVariables ArrayType
 * @subpackage Arrays
 */
class ArrayOfCANVariables extends AbstractStructArrayBase
{
    /**
     * The CANVariables
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CANVariables[]
     */
    public $CANVariables;
    /**
     * Constructor method for ArrayOfCANVariables
     * @uses ArrayOfCANVariables::setCANVariables()
     * @param \StructType\CANVariables[] $cANVariables
     */
    public function __construct(array $cANVariables = array())
    {
        $this
            ->setCANVariables($cANVariables);
    }
    /**
     * Get CANVariables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CANVariables[]|null
     */
    public function getCANVariables()
    {
        return isset($this->CANVariables) ? $this->CANVariables : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCANVariables method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCANVariables method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCANVariablesForArrayConstraintsFromSetCANVariables(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCANVariablesCANVariablesItem) {
            // validation for constraint: itemType
            if (!$arrayOfCANVariablesCANVariablesItem instanceof \StructType\CANVariables) {
                $invalidValues[] = is_object($arrayOfCANVariablesCANVariablesItem) ? get_class($arrayOfCANVariablesCANVariablesItem) : sprintf('%s(%s)', gettype($arrayOfCANVariablesCANVariablesItem), var_export($arrayOfCANVariablesCANVariablesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CANVariables property can only contain items of type \StructType\CANVariables, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CANVariables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CANVariables[] $cANVariables
     * @return \ArrayType\ArrayOfCANVariables
     */
    public function setCANVariables(array $cANVariables = array())
    {
        // validation for constraint: array
        if ('' !== ($cANVariablesArrayErrorMessage = self::validateCANVariablesForArrayConstraintsFromSetCANVariables($cANVariables))) {
            throw new \InvalidArgumentException($cANVariablesArrayErrorMessage, __LINE__);
        }
        if (is_null($cANVariables) || (is_array($cANVariables) && empty($cANVariables))) {
            unset($this->CANVariables);
        } else {
            $this->CANVariables = $cANVariables;
        }
        return $this;
    }
    /**
     * Add item to CANVariables value
     * @throws \InvalidArgumentException
     * @param \StructType\CANVariables $item
     * @return \ArrayType\ArrayOfCANVariables
     */
    public function addToCANVariables(\StructType\CANVariables $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CANVariables) {
            throw new \InvalidArgumentException(sprintf('The CANVariables property can only contain items of type \StructType\CANVariables, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CANVariables[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CANVariables|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CANVariables|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CANVariables|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CANVariables|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CANVariables|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CANVariables
     */
    public function getAttributeName()
    {
        return 'CANVariables';
    }
}
