<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeolocatedPassengerLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfGeolocatedPassengerLog extends AbstractStructArrayBase
{
    /**
     * The GeolocatedPassengerLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GeolocatedPassengerLog[]
     */
    public $GeolocatedPassengerLog;
    /**
     * Constructor method for ArrayOfGeolocatedPassengerLog
     * @uses ArrayOfGeolocatedPassengerLog::setGeolocatedPassengerLog()
     * @param \StructType\GeolocatedPassengerLog[] $geolocatedPassengerLog
     */
    public function __construct(array $geolocatedPassengerLog = array())
    {
        $this
            ->setGeolocatedPassengerLog($geolocatedPassengerLog);
    }
    /**
     * Get GeolocatedPassengerLog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GeolocatedPassengerLog[]|null
     */
    public function getGeolocatedPassengerLog()
    {
        return isset($this->GeolocatedPassengerLog) ? $this->GeolocatedPassengerLog : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGeolocatedPassengerLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGeolocatedPassengerLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGeolocatedPassengerLogForArrayConstraintsFromSetGeolocatedPassengerLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem instanceof \StructType\GeolocatedPassengerLog) {
                $invalidValues[] = is_object($arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem) ? get_class($arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem) : sprintf('%s(%s)', gettype($arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem), var_export($arrayOfGeolocatedPassengerLogGeolocatedPassengerLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GeolocatedPassengerLog property can only contain items of type \StructType\GeolocatedPassengerLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GeolocatedPassengerLog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GeolocatedPassengerLog[] $geolocatedPassengerLog
     * @return \ArrayType\ArrayOfGeolocatedPassengerLog
     */
    public function setGeolocatedPassengerLog(array $geolocatedPassengerLog = array())
    {
        // validation for constraint: array
        if ('' !== ($geolocatedPassengerLogArrayErrorMessage = self::validateGeolocatedPassengerLogForArrayConstraintsFromSetGeolocatedPassengerLog($geolocatedPassengerLog))) {
            throw new \InvalidArgumentException($geolocatedPassengerLogArrayErrorMessage, __LINE__);
        }
        if (is_null($geolocatedPassengerLog) || (is_array($geolocatedPassengerLog) && empty($geolocatedPassengerLog))) {
            unset($this->GeolocatedPassengerLog);
        } else {
            $this->GeolocatedPassengerLog = $geolocatedPassengerLog;
        }
        return $this;
    }
    /**
     * Add item to GeolocatedPassengerLog value
     * @throws \InvalidArgumentException
     * @param \StructType\GeolocatedPassengerLog $item
     * @return \ArrayType\ArrayOfGeolocatedPassengerLog
     */
    public function addToGeolocatedPassengerLog(\StructType\GeolocatedPassengerLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GeolocatedPassengerLog) {
            throw new \InvalidArgumentException(sprintf('The GeolocatedPassengerLog property can only contain items of type \StructType\GeolocatedPassengerLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GeolocatedPassengerLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GeolocatedPassengerLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GeolocatedPassengerLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GeolocatedPassengerLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GeolocatedPassengerLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GeolocatedPassengerLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeolocatedPassengerLog
     */
    public function getAttributeName()
    {
        return 'GeolocatedPassengerLog';
    }
}
