<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItPoint ArrayType
 * @subpackage Arrays
 */
class ArrayOfItPoint extends AbstractStructArrayBase
{
    /**
     * The ItPoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItPoint[]
     */
    public $ItPoint;
    /**
     * Constructor method for ArrayOfItPoint
     * @uses ArrayOfItPoint::setItPoint()
     * @param \StructType\ItPoint[] $itPoint
     */
    public function __construct(array $itPoint = array())
    {
        $this
            ->setItPoint($itPoint);
    }
    /**
     * Get ItPoint value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItPoint[]|null
     */
    public function getItPoint()
    {
        return isset($this->ItPoint) ? $this->ItPoint : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItPoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItPoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItPointForArrayConstraintsFromSetItPoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfItPointItPointItem) {
            // validation for constraint: itemType
            if (!$arrayOfItPointItPointItem instanceof \StructType\ItPoint) {
                $invalidValues[] = is_object($arrayOfItPointItPointItem) ? get_class($arrayOfItPointItPointItem) : sprintf('%s(%s)', gettype($arrayOfItPointItPointItem), var_export($arrayOfItPointItPointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItPoint property can only contain items of type \StructType\ItPoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItPoint value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItPoint[] $itPoint
     * @return \ArrayType\ArrayOfItPoint
     */
    public function setItPoint(array $itPoint = array())
    {
        // validation for constraint: array
        if ('' !== ($itPointArrayErrorMessage = self::validateItPointForArrayConstraintsFromSetItPoint($itPoint))) {
            throw new \InvalidArgumentException($itPointArrayErrorMessage, __LINE__);
        }
        if (is_null($itPoint) || (is_array($itPoint) && empty($itPoint))) {
            unset($this->ItPoint);
        } else {
            $this->ItPoint = $itPoint;
        }
        return $this;
    }
    /**
     * Add item to ItPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\ItPoint $item
     * @return \ArrayType\ArrayOfItPoint
     */
    public function addToItPoint(\StructType\ItPoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItPoint) {
            throw new \InvalidArgumentException(sprintf('The ItPoint property can only contain items of type \StructType\ItPoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItPoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItPoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItPoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItPoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItPoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItPoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItPoint
     */
    public function getAttributeName()
    {
        return 'ItPoint';
    }
}
