<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItPointArrival ArrayType
 * @subpackage Arrays
 */
class ArrayOfItPointArrival extends AbstractStructArrayBase
{
    /**
     * The ItPointArrival
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItPointArrival[]
     */
    public $ItPointArrival;
    /**
     * Constructor method for ArrayOfItPointArrival
     * @uses ArrayOfItPointArrival::setItPointArrival()
     * @param \StructType\ItPointArrival[] $itPointArrival
     */
    public function __construct(array $itPointArrival = array())
    {
        $this
            ->setItPointArrival($itPointArrival);
    }
    /**
     * Get ItPointArrival value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItPointArrival[]|null
     */
    public function getItPointArrival()
    {
        return isset($this->ItPointArrival) ? $this->ItPointArrival : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItPointArrival method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItPointArrival method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItPointArrivalForArrayConstraintsFromSetItPointArrival(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfItPointArrivalItPointArrivalItem) {
            // validation for constraint: itemType
            if (!$arrayOfItPointArrivalItPointArrivalItem instanceof \StructType\ItPointArrival) {
                $invalidValues[] = is_object($arrayOfItPointArrivalItPointArrivalItem) ? get_class($arrayOfItPointArrivalItPointArrivalItem) : sprintf('%s(%s)', gettype($arrayOfItPointArrivalItPointArrivalItem), var_export($arrayOfItPointArrivalItPointArrivalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItPointArrival property can only contain items of type \StructType\ItPointArrival, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItPointArrival value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItPointArrival[] $itPointArrival
     * @return \ArrayType\ArrayOfItPointArrival
     */
    public function setItPointArrival(array $itPointArrival = array())
    {
        // validation for constraint: array
        if ('' !== ($itPointArrivalArrayErrorMessage = self::validateItPointArrivalForArrayConstraintsFromSetItPointArrival($itPointArrival))) {
            throw new \InvalidArgumentException($itPointArrivalArrayErrorMessage, __LINE__);
        }
        if (is_null($itPointArrival) || (is_array($itPointArrival) && empty($itPointArrival))) {
            unset($this->ItPointArrival);
        } else {
            $this->ItPointArrival = $itPointArrival;
        }
        return $this;
    }
    /**
     * Add item to ItPointArrival value
     * @throws \InvalidArgumentException
     * @param \StructType\ItPointArrival $item
     * @return \ArrayType\ArrayOfItPointArrival
     */
    public function addToItPointArrival(\StructType\ItPointArrival $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItPointArrival) {
            throw new \InvalidArgumentException(sprintf('The ItPointArrival property can only contain items of type \StructType\ItPointArrival, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItPointArrival[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItPointArrival|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItPointArrival|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItPointArrival|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItPointArrival|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItPointArrival|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItPointArrival
     */
    public function getAttributeName()
    {
        return 'ItPointArrival';
    }
}
