<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMobileOperationInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfMobileOperationInfo extends AbstractStructArrayBase
{
    /**
     * The MobileOperationInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MobileOperationInfo[]
     */
    public $MobileOperationInfo;
    /**
     * Constructor method for ArrayOfMobileOperationInfo
     * @uses ArrayOfMobileOperationInfo::setMobileOperationInfo()
     * @param \StructType\MobileOperationInfo[] $mobileOperationInfo
     */
    public function __construct(array $mobileOperationInfo = array())
    {
        $this
            ->setMobileOperationInfo($mobileOperationInfo);
    }
    /**
     * Get MobileOperationInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MobileOperationInfo[]|null
     */
    public function getMobileOperationInfo()
    {
        return isset($this->MobileOperationInfo) ? $this->MobileOperationInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMobileOperationInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMobileOperationInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMobileOperationInfoForArrayConstraintsFromSetMobileOperationInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMobileOperationInfoMobileOperationInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfMobileOperationInfoMobileOperationInfoItem instanceof \StructType\MobileOperationInfo) {
                $invalidValues[] = is_object($arrayOfMobileOperationInfoMobileOperationInfoItem) ? get_class($arrayOfMobileOperationInfoMobileOperationInfoItem) : sprintf('%s(%s)', gettype($arrayOfMobileOperationInfoMobileOperationInfoItem), var_export($arrayOfMobileOperationInfoMobileOperationInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MobileOperationInfo property can only contain items of type \StructType\MobileOperationInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MobileOperationInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MobileOperationInfo[] $mobileOperationInfo
     * @return \ArrayType\ArrayOfMobileOperationInfo
     */
    public function setMobileOperationInfo(array $mobileOperationInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($mobileOperationInfoArrayErrorMessage = self::validateMobileOperationInfoForArrayConstraintsFromSetMobileOperationInfo($mobileOperationInfo))) {
            throw new \InvalidArgumentException($mobileOperationInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($mobileOperationInfo) || (is_array($mobileOperationInfo) && empty($mobileOperationInfo))) {
            unset($this->MobileOperationInfo);
        } else {
            $this->MobileOperationInfo = $mobileOperationInfo;
        }
        return $this;
    }
    /**
     * Add item to MobileOperationInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\MobileOperationInfo $item
     * @return \ArrayType\ArrayOfMobileOperationInfo
     */
    public function addToMobileOperationInfo(\StructType\MobileOperationInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MobileOperationInfo) {
            throw new \InvalidArgumentException(sprintf('The MobileOperationInfo property can only contain items of type \StructType\MobileOperationInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MobileOperationInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MobileOperationInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MobileOperationInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MobileOperationInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MobileOperationInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MobileOperationInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MobileOperationInfo
     */
    public function getAttributeName()
    {
        return 'MobileOperationInfo';
    }
}
