<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOdometer ArrayType
 * @subpackage Arrays
 */
class ArrayOfOdometer extends AbstractStructArrayBase
{
    /**
     * The Odometer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Odometer[]
     */
    public $Odometer;
    /**
     * Constructor method for ArrayOfOdometer
     * @uses ArrayOfOdometer::setOdometer()
     * @param \StructType\Odometer[] $odometer
     */
    public function __construct(array $odometer = array())
    {
        $this
            ->setOdometer($odometer);
    }
    /**
     * Get Odometer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Odometer[]|null
     */
    public function getOdometer()
    {
        return isset($this->Odometer) ? $this->Odometer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOdometer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOdometer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOdometerForArrayConstraintsFromSetOdometer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOdometerOdometerItem) {
            // validation for constraint: itemType
            if (!$arrayOfOdometerOdometerItem instanceof \StructType\Odometer) {
                $invalidValues[] = is_object($arrayOfOdometerOdometerItem) ? get_class($arrayOfOdometerOdometerItem) : sprintf('%s(%s)', gettype($arrayOfOdometerOdometerItem), var_export($arrayOfOdometerOdometerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Odometer property can only contain items of type \StructType\Odometer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Odometer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Odometer[] $odometer
     * @return \ArrayType\ArrayOfOdometer
     */
    public function setOdometer(array $odometer = array())
    {
        // validation for constraint: array
        if ('' !== ($odometerArrayErrorMessage = self::validateOdometerForArrayConstraintsFromSetOdometer($odometer))) {
            throw new \InvalidArgumentException($odometerArrayErrorMessage, __LINE__);
        }
        if (is_null($odometer) || (is_array($odometer) && empty($odometer))) {
            unset($this->Odometer);
        } else {
            $this->Odometer = $odometer;
        }
        return $this;
    }
    /**
     * Add item to Odometer value
     * @throws \InvalidArgumentException
     * @param \StructType\Odometer $item
     * @return \ArrayType\ArrayOfOdometer
     */
    public function addToOdometer(\StructType\Odometer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Odometer) {
            throw new \InvalidArgumentException(sprintf('The Odometer property can only contain items of type \StructType\Odometer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Odometer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Odometer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Odometer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Odometer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Odometer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Odometer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Odometer
     */
    public function getAttributeName()
    {
        return 'Odometer';
    }
}
