<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPayments_Driver ArrayType
 * @subpackage Arrays
 */
class ArrayOfPayments_Driver extends AbstractStructArrayBase
{
    /**
     * The Payments_Driver
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Payments_Driver[]
     */
    public $Payments_Driver;
    /**
     * Constructor method for ArrayOfPayments_Driver
     * @uses ArrayOfPayments_Driver::setPayments_Driver()
     * @param \StructType\Payments_Driver[] $payments_Driver
     */
    public function __construct(array $payments_Driver = array())
    {
        $this
            ->setPayments_Driver($payments_Driver);
    }
    /**
     * Get Payments_Driver value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Payments_Driver[]|null
     */
    public function getPayments_Driver()
    {
        return isset($this->Payments_Driver) ? $this->Payments_Driver : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPayments_Driver method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayments_Driver method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePayments_DriverForArrayConstraintsFromSetPayments_Driver(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPayments_DriverPayments_DriverItem) {
            // validation for constraint: itemType
            if (!$arrayOfPayments_DriverPayments_DriverItem instanceof \StructType\Payments_Driver) {
                $invalidValues[] = is_object($arrayOfPayments_DriverPayments_DriverItem) ? get_class($arrayOfPayments_DriverPayments_DriverItem) : sprintf('%s(%s)', gettype($arrayOfPayments_DriverPayments_DriverItem), var_export($arrayOfPayments_DriverPayments_DriverItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payments_Driver property can only contain items of type \StructType\Payments_Driver, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payments_Driver value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_Driver[] $payments_Driver
     * @return \ArrayType\ArrayOfPayments_Driver
     */
    public function setPayments_Driver(array $payments_Driver = array())
    {
        // validation for constraint: array
        if ('' !== ($payments_DriverArrayErrorMessage = self::validatePayments_DriverForArrayConstraintsFromSetPayments_Driver($payments_Driver))) {
            throw new \InvalidArgumentException($payments_DriverArrayErrorMessage, __LINE__);
        }
        if (is_null($payments_Driver) || (is_array($payments_Driver) && empty($payments_Driver))) {
            unset($this->Payments_Driver);
        } else {
            $this->Payments_Driver = $payments_Driver;
        }
        return $this;
    }
    /**
     * Add item to Payments_Driver value
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_Driver $item
     * @return \ArrayType\ArrayOfPayments_Driver
     */
    public function addToPayments_Driver(\StructType\Payments_Driver $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Payments_Driver) {
            throw new \InvalidArgumentException(sprintf('The Payments_Driver property can only contain items of type \StructType\Payments_Driver, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Payments_Driver[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Payments_Driver|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Payments_Driver|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Payments_Driver|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Payments_Driver|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Payments_Driver|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Payments_Driver
     */
    public function getAttributeName()
    {
        return 'Payments_Driver';
    }
}
