<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPayments_Route ArrayType
 * @subpackage Arrays
 */
class ArrayOfPayments_Route extends AbstractStructArrayBase
{
    /**
     * The Payments_Route
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Payments_Route[]
     */
    public $Payments_Route;
    /**
     * Constructor method for ArrayOfPayments_Route
     * @uses ArrayOfPayments_Route::setPayments_Route()
     * @param \StructType\Payments_Route[] $payments_Route
     */
    public function __construct(array $payments_Route = array())
    {
        $this
            ->setPayments_Route($payments_Route);
    }
    /**
     * Get Payments_Route value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Payments_Route[]|null
     */
    public function getPayments_Route()
    {
        return isset($this->Payments_Route) ? $this->Payments_Route : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPayments_Route method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayments_Route method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePayments_RouteForArrayConstraintsFromSetPayments_Route(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPayments_RoutePayments_RouteItem) {
            // validation for constraint: itemType
            if (!$arrayOfPayments_RoutePayments_RouteItem instanceof \StructType\Payments_Route) {
                $invalidValues[] = is_object($arrayOfPayments_RoutePayments_RouteItem) ? get_class($arrayOfPayments_RoutePayments_RouteItem) : sprintf('%s(%s)', gettype($arrayOfPayments_RoutePayments_RouteItem), var_export($arrayOfPayments_RoutePayments_RouteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payments_Route property can only contain items of type \StructType\Payments_Route, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payments_Route value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_Route[] $payments_Route
     * @return \ArrayType\ArrayOfPayments_Route
     */
    public function setPayments_Route(array $payments_Route = array())
    {
        // validation for constraint: array
        if ('' !== ($payments_RouteArrayErrorMessage = self::validatePayments_RouteForArrayConstraintsFromSetPayments_Route($payments_Route))) {
            throw new \InvalidArgumentException($payments_RouteArrayErrorMessage, __LINE__);
        }
        if (is_null($payments_Route) || (is_array($payments_Route) && empty($payments_Route))) {
            unset($this->Payments_Route);
        } else {
            $this->Payments_Route = $payments_Route;
        }
        return $this;
    }
    /**
     * Add item to Payments_Route value
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_Route $item
     * @return \ArrayType\ArrayOfPayments_Route
     */
    public function addToPayments_Route(\StructType\Payments_Route $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Payments_Route) {
            throw new \InvalidArgumentException(sprintf('The Payments_Route property can only contain items of type \StructType\Payments_Route, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Payments_Route[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Payments_Route|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Payments_Route|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Payments_Route|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Payments_Route|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Payments_Route|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Payments_Route
     */
    public function getAttributeName()
    {
        return 'Payments_Route';
    }
}
