<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPayments_TransferGeofence ArrayType
 * @subpackage Arrays
 */
class ArrayOfPayments_TransferGeofence extends AbstractStructArrayBase
{
    /**
     * The Payments_TransferGeofence
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Payments_TransferGeofence[]
     */
    public $Payments_TransferGeofence;
    /**
     * Constructor method for ArrayOfPayments_TransferGeofence
     * @uses ArrayOfPayments_TransferGeofence::setPayments_TransferGeofence()
     * @param \StructType\Payments_TransferGeofence[] $payments_TransferGeofence
     */
    public function __construct(array $payments_TransferGeofence = array())
    {
        $this
            ->setPayments_TransferGeofence($payments_TransferGeofence);
    }
    /**
     * Get Payments_TransferGeofence value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Payments_TransferGeofence[]|null
     */
    public function getPayments_TransferGeofence()
    {
        return isset($this->Payments_TransferGeofence) ? $this->Payments_TransferGeofence : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPayments_TransferGeofence method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayments_TransferGeofence method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePayments_TransferGeofenceForArrayConstraintsFromSetPayments_TransferGeofence(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem instanceof \StructType\Payments_TransferGeofence) {
                $invalidValues[] = is_object($arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem) ? get_class($arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem) : sprintf('%s(%s)', gettype($arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem), var_export($arrayOfPayments_TransferGeofencePayments_TransferGeofenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payments_TransferGeofence property can only contain items of type \StructType\Payments_TransferGeofence, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payments_TransferGeofence value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_TransferGeofence[] $payments_TransferGeofence
     * @return \ArrayType\ArrayOfPayments_TransferGeofence
     */
    public function setPayments_TransferGeofence(array $payments_TransferGeofence = array())
    {
        // validation for constraint: array
        if ('' !== ($payments_TransferGeofenceArrayErrorMessage = self::validatePayments_TransferGeofenceForArrayConstraintsFromSetPayments_TransferGeofence($payments_TransferGeofence))) {
            throw new \InvalidArgumentException($payments_TransferGeofenceArrayErrorMessage, __LINE__);
        }
        if (is_null($payments_TransferGeofence) || (is_array($payments_TransferGeofence) && empty($payments_TransferGeofence))) {
            unset($this->Payments_TransferGeofence);
        } else {
            $this->Payments_TransferGeofence = $payments_TransferGeofence;
        }
        return $this;
    }
    /**
     * Add item to Payments_TransferGeofence value
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_TransferGeofence $item
     * @return \ArrayType\ArrayOfPayments_TransferGeofence
     */
    public function addToPayments_TransferGeofence(\StructType\Payments_TransferGeofence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Payments_TransferGeofence) {
            throw new \InvalidArgumentException(sprintf('The Payments_TransferGeofence property can only contain items of type \StructType\Payments_TransferGeofence, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Payments_TransferGeofence[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Payments_TransferGeofence|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Payments_TransferGeofence|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Payments_TransferGeofence|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Payments_TransferGeofence|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Payments_TransferGeofence|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Payments_TransferGeofence
     */
    public function getAttributeName()
    {
        return 'Payments_TransferGeofence';
    }
}
