<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrackerEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfTrackerEvent extends AbstractStructArrayBase
{
    /**
     * The TrackerEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrackerEvent[]
     */
    public $TrackerEvent;
    /**
     * Constructor method for ArrayOfTrackerEvent
     * @uses ArrayOfTrackerEvent::setTrackerEvent()
     * @param \StructType\TrackerEvent[] $trackerEvent
     */
    public function __construct(array $trackerEvent = array())
    {
        $this
            ->setTrackerEvent($trackerEvent);
    }
    /**
     * Get TrackerEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrackerEvent[]|null
     */
    public function getTrackerEvent()
    {
        return isset($this->TrackerEvent) ? $this->TrackerEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTrackerEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTrackerEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTrackerEventForArrayConstraintsFromSetTrackerEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTrackerEventTrackerEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfTrackerEventTrackerEventItem instanceof \StructType\TrackerEvent) {
                $invalidValues[] = is_object($arrayOfTrackerEventTrackerEventItem) ? get_class($arrayOfTrackerEventTrackerEventItem) : sprintf('%s(%s)', gettype($arrayOfTrackerEventTrackerEventItem), var_export($arrayOfTrackerEventTrackerEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TrackerEvent property can only contain items of type \StructType\TrackerEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TrackerEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TrackerEvent[] $trackerEvent
     * @return \ArrayType\ArrayOfTrackerEvent
     */
    public function setTrackerEvent(array $trackerEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($trackerEventArrayErrorMessage = self::validateTrackerEventForArrayConstraintsFromSetTrackerEvent($trackerEvent))) {
            throw new \InvalidArgumentException($trackerEventArrayErrorMessage, __LINE__);
        }
        if (is_null($trackerEvent) || (is_array($trackerEvent) && empty($trackerEvent))) {
            unset($this->TrackerEvent);
        } else {
            $this->TrackerEvent = $trackerEvent;
        }
        return $this;
    }
    /**
     * Add item to TrackerEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\TrackerEvent $item
     * @return \ArrayType\ArrayOfTrackerEvent
     */
    public function addToTrackerEvent(\StructType\TrackerEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TrackerEvent) {
            throw new \InvalidArgumentException(sprintf('The TrackerEvent property can only contain items of type \StructType\TrackerEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TrackerEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TrackerEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TrackerEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TrackerEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TrackerEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TrackerEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrackerEvent
     */
    public function getAttributeName()
    {
        return 'TrackerEvent';
    }
}
