<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for GETP ServiceType
 * @subpackage Services
 */
class GETP extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GET_PassengersCounter
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GET_PassengersCounter $parameters
     * @return \StructType\GET_PassengersCounterResponse|bool
     */
    public function GET_PassengersCounter(\StructType\GET_PassengersCounter $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GET_PassengersCounter($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GET_PassengersCounterResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
